import React from 'react';
import ajax from 'jquery/src/ajax/xhr.js';
import $ from 'jquery/src/ajax';
import { Form, Button, Input, Select, Spin,InputNumber, message, Modal ,DatePicker} from 'antd';
import {transactionProject,transactionChannel} from '@/dataDic.js';
import moment from 'moment';

const Receivable=React.createClass({
    loadData(record) {
        this.state.data = {};
        this.setState({
            loading: true
        });
        $.ajax({
            method: "get",
            dataType: "json",
            crossDomain: false,
            url: globalConfig.context + '/api/admin/order/getOrderCommodity',
            data: {
            	orderNo:record?record.orderNo:this.props.data.orderNo
            },
            success: function (data) {
                let thisData = data.data;
                if (!thisData) {
                    if (data.error && data.error.length) {
                        message.warning(data.error[0].message);
                    };
                    thisData = {};
                };
                this.setState({
                    orderNo:thisData.orderNo,
                    payeeId:thisData.payeeId,
                    payerId:thisData.payerId,
                    data: thisData,
                });
            }.bind(this),
        }).always(function () {
            this.setState({
                loading: false
            });
        }.bind(this));
    },
    getInitialState() {
        return {
            loading: false,
            visible:false,
            showDesc:false,
        };
    },
    //保存
    handleSubmit(e){
        e.preventDefault();
        if(!this.state.settlementAmount){
                message.warning('请填写金额');
                return false;
        }
        if(!this.state.transactionProject){
            message.warning('请选择流水科目');
            return false;
        }
        if(!this.state.transactionChannel){
            message.warning('请选择交易渠道');
            return false;
        }
        this.setState({
            loading: true
        });
        $.ajax({
            method: "post",
            dataType: "json",
            async:true,
            url:  globalConfig.context + '/api/user/demand/apply',
            data: {
                orderNo: this.props.data.orderNo,
                payeeId:this.state.payeeId,
                payerId:this.state.payerId,
                transactionAmount: this.state.settlementAmount,
                transactionSubject: this.state.transactionProject,
                transactionChannel: this.state.transactionChannel,
                financialPayNo:this.state.financialPayNo,
                financialPayTimes:this.state.financialPayTimes,
                remarks:this.state.remarks
            }
        }).done(function (data) {
            this.setState({
                loading: false
            });
            if (!data.error.length) {
                message.success('操作成功！');
                this.onShow();
            } else {
                message.warning(data.error[0].message);
            }
        }.bind(this));
    },
    onCancel(){
    	this.setState({
    		visible:false
        })
        this.props.closeDesc(false,false);
    },
    onShow() {
		this.setState({
			visible: false,
		});
		this.props.closeDesc(false, true);
	},
    componentWillMount() {
        this.setState({
            transactionProject:undefined,
            settlementAmount:undefined,
            transactionChannel:undefined,
            financialPayNo:'',
            financialPayTimes:undefined,
            remarks:''
        })
    },
    componentWillReceiveProps(nextProps) {
        if(nextProps.data.orderNo){
            this.loadData(nextProps.data);
        }
        this.state.visible=nextProps.showDesc;
        this.setState({
            transactionProject:undefined,
            settlementAmount:undefined,
            transactionChannel:undefined,
            financialPayNo:'',
            financialPayTimes:undefined,
            remarks:''
        })
    },
    render() {
        const theData = this.state.data || {};
        const { getFieldDecorator,getFieldsValue } = this.props.form;
        const FormItem = Form.Item;
        const formItemLayout = {
            labelCol: { span: 8 },
            wrapperCol: { span: 12 },
		};
        return (
            <div className="user-content" >
	            <Modal maskClosable={false} visible={this.state.visible}
                        onOk={this.onShow} onCancel={this.onCancel}
                        width='800px'
                        title='添加收款记录'                     
                        footer=''
                        className="admin-desc-content">
			            <Form layout="horizontal" onSubmit={this.handleSubmit} >
			                <Spin spinning={this.state.loading}>
                                <div className="clearfix">
                                    <FormItem className="half-item" {...formItemLayout} label="付款方">
                                        <span>{theData.name}</span>
                                    </FormItem>
                                    <FormItem className="half-item" {...formItemLayout} label="收款方">
                                        <span>{theData.name}</span>
                                    </FormItem>
                                    <FormItem className="half-item" {...formItemLayout} label={<span><strong style={{color:'#f00'}}>*</strong>金额</span>}>
                                        <InputNumber min={0} max={9999} placeholder="金额" 
                                            value={this.state.settlementAmount}
                                            onChange={(e)=>{this.setState({settlementAmount:e})}}
                                        />
                                        <span style={{ marginLeft: '5px' }}>万元</span>
                                    </FormItem>
                                    <FormItem className="half-item" {...formItemLayout} label={<span><strong style={{color:'#f00'}}>*</strong>流水科目</span>}>
                                        <Select placeholder="流水科目" 
                                            value={this.state.transactionProject}
                                            onChange={(e)=>{this.setState({transactionProject:e})}}
                                            >
                                            { 
                                                transactionProject.map(function (item) {
                                                    return	<Select.Option value={item.value} key={item.key}>{item.key}</Select.Option>
                                                })
                                            }
                                        </Select>
                                    </FormItem>
                                    <FormItem className="half-item" {...formItemLayout} label={<span><strong style={{color:'#f00'}}>*</strong>交易渠道</span>}>
                                        <Select placeholder="交易渠道" 
                                            value={this.state.transactionChannel}
                                            onChange={(e)=>{this.setState({transactionChannel:e})}}
                                        >
                                            { 
                                                transactionChannel.map(function (item) {
                                                    return	<Select.Option value={item.value} key={item.key}>{item.key}</Select.Option>
                                                })
                                            }
                                        </Select>
                                    </FormItem>
                                    <FormItem className="half-item" {...formItemLayout} label="订单编号">
                                        <span>{theData.orderNo}</span>
                                    </FormItem>
                                    <FormItem className="half-item" {...formItemLayout} label="财务流水编号">
                                        <Input placeholder="财务流水编号"
                                            value={this.state.financialPayNo}
                                            onChange={(e) => { this.setState({ financialPayNo: e.target.value }); }} />  
                                                        
                                    </FormItem>
                                    <FormItem className="half-item" {...formItemLayout} label="财务流水时间">
                                        <DatePicker
                                            value={this.state.financialPayTimes ? moment(this.state.financialPayTimes) : null}
                                            onChange={(data, dataString) => { this.setState({ financialPayTimes: dataString }); }} />
                                    </FormItem>
                                    <FormItem labelCol={{ span: 4 }} wrapperCol={{ span: 16 }} label="备注">
                                        <Input
                                            type="textarea"
                                            rows={4}
                                            placeholder="请输入备注"
                                            value={this.state.remarks}
                                            onChange={(e) => {
                                                this.setState({ remarks: e.target.value });
                                            }}
                                        />
                                    </FormItem>
                                    <FormItem wrapperCol={{ span: 12, offset:5 }}>  
                                        <Button type="primary" htmlType="submit"  style={{marginRight:20}}>确认</Button>
                                        <Button type="default" onClick={()=>{this.onCancel()}}>取消</Button>
                                    </FormItem>  
                                </div>
			                </Spin>
			            </Form>
			    </Modal>
            </div>
        );
    }
});

export default Form.create()(Receivable);