import React from 'react';
import ajax from 'jquery/src/ajax/xhr.js';
import $ from 'jquery/src/ajax';
import moment from 'moment';
import '../distribute/public.less';
import {  Button, Input, Spin, Table, Switch, message, DatePicker } from 'antd';
import {getTransactionChannel,getTransactionProject} from '@/tools';
import WaterDesc from './waterDetail';

const MyWater = React.createClass({
    loadData(pageNo) {
        this.state.data = [];
        this.setState({
            page:pageNo,
            loading: true
        });
        $.ajax({
            method: "post",
            dataType: "json",
            crossDomain: false,
            url: globalConfig.context + "/api/admin/order/listAllSettlement",
            data: {
                pageNo: pageNo || 1,
                pageSize: this.state.pagination.pageSize,
                ownerName: this.state.nameSearch,//客户名称
                orderNo:this.state.orderNoSearch,
                startDate: this.state.releaseDate[0],
                endDate: this.state.releaseDate[1],
            },
            success: function (data) {
                let theArr = [];
                if (!data.data || !data.data.list) {
                    if (data.error && data.error.length) {
                        message.warning(data.error[0].message);
                    };
                } else {
                    for (let i = 0; i < data.data.list.length; i++) {
                        let thisdata = data.data.list[i];
                        theArr.push({
                            key: i,
		                    orderNo: thisdata.orderNo,
		                    orderType:thisdata.orderType,
		                    orderStatus:thisdata.orderStatus,
		                    processStatus:thisdata.processStatus,
		                    projectStage:thisdata.projectStage,
		                    approval:thisdata.approval,
		                    creater:thisdata.creater,
                            createTime:thisdata.createTime?(new Date(thisdata.createTime)).toLocaleString():'',
                            signTime:thisdata.releaseDate?(new Date(thisdata.releaseDate)).toLocaleString():''
                        });
                    };
                }
                this.state.pagination.current = data.data.pageNo;
                this.state.pagination.total = data.data.totalCount;
                if(data.data&&data.data.list&&!data.data.list.length){
					this.state.pagination.current=0
					this.state.pagination.total=0
				}
                this.setState({
                    dataSource: theArr,
                    pagination: this.state.pagination
                });
            }.bind(this),
        }).always(function () {
            this.setState({
                loading: false
            });
        }.bind(this));
    },
    getInitialState() {
        return {
            searchMore: true,
            releaseDate: [],
            RowData:{},
            selectedRowKeys: [],
            selectedRows: [],
            loading: false,
            pagination: {
                defaultCurrent: 1,
                defaultPageSize: 10,
                showQuickJumper: true,
                pageSize: 10,
                onChange: function (page) {
                    this.loadData(page);
                }.bind(this),
                showTotal: function (total) {
                    return '共' + total + '条数据';
                }
            },
            columns: [
                {
                    title: '平台流水号',
                    dataIndex: 'id',
                    key: 'id',   
                },
                {
                    title: '平台流水时间',
                    dataIndex: 'createTime',
                    key: 'createTime',
                }, 
                {
                    title: '金额',
                    dataIndex: 'orderNo1',
                    key: 'orderNo1',
                },
                {
                    title: '流水科目',
                    dataIndex: 'creater',
                    key: 'creater',
                    render: text => { return getTransactionProject(text)}
                },
                {
                    title: '交易时间',
                    dataIndex: 'liquidationStatus1',
                    key: 'liquidationStatus1',
                }, {
                    title: '财务流水号',
                    dataIndex: 'creater1',
                    key: 'creater1'
                },
                {
                    title: '订单编号',
                    dataIndex: 'orderNo',
                    key: 'orderNo'
                },{
                    title: '订单负责人',
                    dataIndex: 'creater3',
                    key: 'creater3'
                },
            ],
            dataSource: [],
            searchTime: [,]
        }
    },
    componentWillMount() {
        this.loadData();
    },
    tableRowClick(record, index) {
        this.state.RowData = record;
        this.setState({
            showDesc: true,
        });
    },
    closeDesc(e, s) {
        this.state.RowData={};
        this.state.showDesc = e;
        if (s) {
            this.loadData(this.state.page);
        };
    },
    search() {
        this.loadData();
    },
    reset() {
        this.state.orderRefundSearch='';
        this.state.releaseDate = [];
        this.state.orderNoSearch='';
        this.loadData();
    },
    searchSwitch() {
        this.setState({
            searchMore: !this.state.searchMore
        });
    },
    render() { 
        const rowSelection = {
            selectedRowKeys: this.state.selectedRowKeys,
            onChange: (selectedRowKeys, selectedRows) => {
                this.setState({
                    selectedRows: selectedRows.slice(-1),
                    selectedRowKeys: selectedRowKeys.slice(-1)
                });
            }
        };
        const hasSelected = this.state.selectedRowKeys.length > 0;
        const { RangePicker } = DatePicker;
        return ( <div className="user-content">
            <div className="content-title">
                <span>我的流水订单</span>
                </div>
                <div className="user-search">
                    <Input placeholder="收款方"
                        value={this.state.orderRefundSearch}
                        onChange={(e) => { this.setState({ orderRefundSearch: e.target.value }); }} /> 
                    <Input placeholder="付款方"
                        value={this.state.orderNoSearch}
                        onChange={(e) => { this.setState({ orderNoSearch: e.target.value }); }} />  
                    <Button type="primary" onClick={this.search}>搜索</Button>
                    <Button onClick={this.reset}>重置</Button>
                    <span>更多搜索<Switch defaultChecked={false} onChange={this.searchSwitch.bind(this)} /></span>
                    <div className="search-more" style={this.state.searchMore ? { display: 'none' } : {}}>
                        <span>流水时间 :</span>
                        <RangePicker
                            value={[this.state.releaseDate[0] ? moment(this.state.releaseDate[0]) : null,
                            this.state.releaseDate[1] ? moment(this.state.releaseDate[1]) : null]}
                            onChange={(data, dataString) => { this.setState({ releaseDate: dataString }); }} />
                    </div>
                </div>
                <div className="patent-table">
                    <Spin spinning={this.state.loading}>
                        <Table columns={this.state.columns}
                            dataSource={this.state.dataSource}
                            rowSelection={rowSelection}
                            pagination={this.state.pagination}
                            onRowClick={this.tableRowClick}
                             />
                    </Spin>
                </div>
                <WaterDesc
                    data={this.state.RowData}
                    showDesc={this.state.showDesc}
                    closeDesc={this.closeDesc.bind(this)}
                />
        </div> )
    }
})
 
export default MyWater;