import React from 'react';
import ajax from 'jquery/src/ajax/xhr.js';
import $ from 'jquery/src/ajax';
import { Form,Button, Input, Spin, message, Modal, Upload } from 'antd';
import {getTransactionChannel,getTransactionProject,splitUrl} from '@/tools.js';

const WaterDetail=React.createClass({
    loadData(record) {
        this.state.data = [];
        this.setState({
            loading: true
        });
        $.ajax({
            method: "get",
            dataType: "json",
            crossDomain: false,
            url: globalConfig.context + '/api/admin/order/getOrderCommodity',
            data: {
            	orderNo:record?record.orderNo:this.props.data.orderNo
            },
            success: function (data) {
                let theArr = [];
                if (!data.data) {
                    if (data.error && data.error.length) {
                        message.warning(data.error[0].message);
                    };
                } else {
                    for (let i = 0; i < data.data.length; i++) {
                        let thisdata = data.data[i];
                        theArr.push({
                             key: i,
                             id:thisdata.id,
                             data:thisdata,
                             orderNo:thisdata.orderNo,
                             orgCodeUrl: thisdata.contractPictureUrl ? splitUrl(thisdata.contractPictureUrl, ',', globalConfig.avatarHost + '/upload') : [],
                             orgCodeUrlNo: thisdata.contractPictureUrl ? splitUrl(thisdata.contractPictureUrl, ',', globalConfig.avatarHost + '/upload') : [],
                        });
                    };
                   }
            }.bind(this),
        }).always(function () {
            this.setState({
                loading: false
            });
        }.bind(this));
    },
    getInitialState() {
        return {
            loading: false,
            visible:false,
            showDesc:false,
        };
    },
    onCancel(){
    	this.setState({
    		visible:false
        })
        this.props.closeDesc(false,false);
    },
    onShow() {
		this.setState({
			visible: false,
		});
		this.props.closeDesc(false, true);
	},
    componentWillMount() {
    },
    componentWillReceiveProps(nextProps) {
        if(nextProps.data.orderNo){
            this.loadData(nextProps.data);
        }
        this.state.visible=nextProps.showDesc;
    },
    render() {
        const theData = this.state.data || {};
        const FormItem = Form.Item;
        const formItemLayout = {
            labelCol: { span: 10 },
            wrapperCol: { span: 12 },
		};
        return (
            <div className="user-content" >
	            <Modal maskClosable={false} visible={this.state.visible}
                        onOk={this.onShow} onCancel={this.onCancel}
                        width='800px'
                        title='流水详情'                     
                        footer=''
                        className="admin-desc-content">
			            <Form layout="horizontal" onSubmit={(e)=>{this.handleSubmit(e,0)}} >
			                <Spin spinning={this.state.loading}>
                                <div className="clearfix">
                                    <FormItem className="half-item" {...formItemLayout} label="平台流水编号">
                                        <span>{theData.name}</span>
                                    </FormItem>
                                    <FormItem className="half-item" {...formItemLayout} label="平台流水时间">
							            <span>{theData.releaseDate?(new Date(theData.releaseDate)).toLocaleString():''}</span>
                                    </FormItem>
                                    <FormItem className="half-item" {...formItemLayout} label="金额">
                                        <span>{theData.orderNo}</span>
                                    </FormItem>
                                    <FormItem className="half-item" {...formItemLayout} label="流水科目">
                                        <span>{getTransactionProject(theData.orderState)}</span>
                                    </FormItem>
                                    <FormItem className="half-item" {...formItemLayout} label="付款方">
                                        <span>{theData.name}</span>
                                    </FormItem>
                                    <FormItem className="half-item" {...formItemLayout} label="收款方">
                                        <span>{theData.name}</span>
                                    </FormItem>
                                    <FormItem className="half-item" {...formItemLayout} label="交易渠道">
                                        <span>{getTransactionChannel(theData.liquidationStatus)}</span>
                                    </FormItem>
                                    <FormItem className="half-item" {...formItemLayout} label="订单编号">
                                        <span>{theData.orderNo}</span>
                                    </FormItem>
                                    <FormItem className="half-item" {...formItemLayout} label="财务流水编号">
                                        <span>{theData.orderNo}</span>
                                    </FormItem>
                                    <FormItem labelCol={{ span: 5 }} wrapperCol={{ span: 16 }} label="备注">
                                        <span>{theData.remark}</span>
                                    </FormItem>
                                </div>
			                </Spin>
			            </Form>
			    </Modal>
            </div>
        );
    }
});

export default Form.create()(WaterDetail);